searchData={"items":[{"type":"module","doc":"Extend `Commanded` package. A swiss army knife for applications following Domain-Driven Design (DDD), Event Sourcing\n(ES), and Command and Query Responsibility Segregation (CQRS).","title":"Trogon.Commanded","ref":"Trogon.Commanded.html"},{"type":"function","doc":"See  Trogon.Commanded.Helpers.cast_to/3 .","title":"Trogon.Commanded.cast_to/3","ref":"Trogon.Commanded.html#cast_to/3"},{"type":"function","doc":"See  Trogon.Commanded.Helpers.ignore_error/2 .","title":"Trogon.Commanded.ignore_error/2","ref":"Trogon.Commanded.html#ignore_error/2"},{"type":"function","doc":"See  Trogon.Commanded.Helpers.increase_failure_counter/1 .","title":"Trogon.Commanded.increase_failure_counter/1","ref":"Trogon.Commanded.html#increase_failure_counter/1"},{"type":"function","doc":"See  Trogon.Commanded.Helpers.skip_or_retry/2 .","title":"Trogon.Commanded.skip_or_retry/2","ref":"Trogon.Commanded.html#skip_or_retry/2"},{"type":"function","doc":"See  Trogon.Commanded.Helpers.skip_or_retry/3 .","title":"Trogon.Commanded.skip_or_retry/3","ref":"Trogon.Commanded.html#skip_or_retry/3"},{"type":"function","doc":"See  Trogon.Commanded.Helpers.tracing_from_metadata/1 .","title":"Trogon.Commanded.tracing_from_metadata/1","ref":"Trogon.Commanded.html#tracing_from_metadata/1"},{"type":"function","doc":"See  Trogon.Commanded.Helpers.tracing_from_metadata/2 .","title":"Trogon.Commanded.tracing_from_metadata/2","ref":"Trogon.Commanded.html#tracing_from_metadata/2"},{"type":"module","doc":"Stops the aggregate after a command, event or error.","title":"Trogon.Commanded.Aggregate.StatelessLifespan","ref":"Trogon.Commanded.Aggregate.StatelessLifespan.html"},{"type":"function","doc":"Stops the aggregate after a command.\n    iex> Trogon.Commanded.Aggregate.StatelessLifespan.after_command(%MyCommandOne{})\n    :stop","title":"Trogon.Commanded.Aggregate.StatelessLifespan.after_command/1","ref":"Trogon.Commanded.Aggregate.StatelessLifespan.html#after_command/1"},{"type":"function","doc":"Stops the aggregate after an error.\n    iex> Trogon.Commanded.Aggregate.StatelessLifespan.after_error({:error, :something_happened})\n    :stop","title":"Trogon.Commanded.Aggregate.StatelessLifespan.after_error/1","ref":"Trogon.Commanded.Aggregate.StatelessLifespan.html#after_error/1"},{"type":"function","doc":"Stops the aggregate after an event.\n    iex> Trogon.Commanded.Aggregate.StatelessLifespan.after_event(%DepositAccountOpened{})\n    :stop","title":"Trogon.Commanded.Aggregate.StatelessLifespan.after_event/1","ref":"Trogon.Commanded.Aggregate.StatelessLifespan.html#after_event/1"},{"type":"module","doc":"Defines a module as a \"Command Handler\". For more information about commands, please read the following:\n\n- [CQRS pattern](https://docs.microsoft.com/en-us/azure/architecture/patterns/cqrs)","title":"Trogon.Commanded.CommandHandler","ref":"Trogon.Commanded.CommandHandler.html"},{"type":"macro","doc":"Convert the module into a `Commanded.Commands.Handler`.\n\nUse `Commanded.Aggregate.Multi` to generate multiple events from\na single command. This can be useful when you want to emit multiple events\nthat depend upon the aggregate state being updated.","title":"Trogon.Commanded.CommandHandler.__using__/1","ref":"Trogon.Commanded.CommandHandler.html#__using__/1"},{"type":"macro","doc":"defmodule MyCommandHandler do\n      use Trogon.Commanded.CommandHandler\n\n      @impl Commanded.Commands.Handler\n      def handle(account, command) do\n        account\n        |> Multi.new()\n        |> Multi.execute(&withdraw_money(&1, command.amount))\n        |> Multi.execute(&check_balance/1)\n      end\n\n      defp withdraw_money(account, amount) do\n        # ...\n      end\n\n      defp check_balance(account, amount) do\n        # ...\n      end\n    end","title":"Usage - Trogon.Commanded.CommandHandler.__using__/1","ref":"Trogon.Commanded.CommandHandler.html#__using__/1-usage"},{"type":"module","doc":"Command routing macro to allow configuration of each command to its command handler.\n\nPlease read more about `Commanded.Commands.Router`.","title":"Trogon.Commanded.CommandRouter","ref":"Trogon.Commanded.CommandRouter.html"},{"type":"macro","doc":"An extension of `Commanded.Commands.Router` that imports extra macros.","title":"Trogon.Commanded.CommandRouter.__using__/1","ref":"Trogon.Commanded.CommandRouter.html#__using__/1"},{"type":"macro","doc":"defmodule Router do\n      use Trogon.Commanded.CommandRouter\n    end","title":"Usage - Trogon.Commanded.CommandRouter.__using__/1","ref":"Trogon.Commanded.CommandRouter.html#__using__/1-usage"},{"type":"macro","doc":"Identify a given aggregate.","title":"Trogon.Commanded.CommandRouter.identify_aggregate/1","ref":"Trogon.Commanded.CommandRouter.html#identify_aggregate/1"},{"type":"macro","doc":"defmodule BankAccount do\n      use Trogon.Commanded.Aggregate\n        identifier: :uuid,\n        identity_prefix: \"bank-account-\"\n\n      embedded_schema do\n        # ...\n      end\n    end\n\n    defmodule Router do\n      use Trogon.Commanded.CommandRouter\n      identify_aggregate BankAccount\n    end","title":"Example - Trogon.Commanded.CommandRouter.identify_aggregate/1","ref":"Trogon.Commanded.CommandRouter.html#identify_aggregate/1-example"},{"type":"macro","doc":"Configure the command to be dispatched to the same command module.","title":"Trogon.Commanded.CommandRouter.register_transaction_script/2","ref":"Trogon.Commanded.CommandRouter.html#register_transaction_script/2"},{"type":"macro","doc":"defmodule Router do\n      use Trogon.Commanded.CommandRouter\n      register_transaction_script OpenBankAccount,\n        aggregate: BankAccount\n    end\n\n    defmodule Router do\n      use Trogon.Commanded.CommandRouter\n      # the aggregate module is `OpenBankAccount.Aggregate`\n      register_transaction_script OpenBankAccount\n    end\n\n\nSimilar to `Commanded.Commands.Router.dispatch/2` except that,\n\n1. It uses the command module as the command handler as well.\n2. It uses the command module's aggregate identifier configuration.\n3. When no lifespan module is provided, it uses `Trogon.Commanded.Aggregate.StatelessLifespan`. as the lifespan\n   module to avoid OOM errors. Reliability is more important than performance.\n4. When no aggregate module is provided, it uses the command module name suffixed concat with `Aggregate` as the\n   aggregate module.\n   As an example, if the command module is `OpenBankAccount`, then the aggregate module is\n   `OpenBankAccount.Aggregate`.\n5. Drops some options to avoid conflicts with the command module configuration.","title":"Example - Trogon.Commanded.CommandRouter.register_transaction_script/2","ref":"Trogon.Commanded.CommandRouter.html#register_transaction_script/2-example"},{"type":"macro","doc":"The naming comes from [Transaction Script from Martin Fowler](https://martinfowler.com/eaaCatalog/transactionScript.html),\nalthough it is not exactly the same since the original name is about database transactions, the key part is the\nfollowing sentence:\n\n> A Transaction Script organizes all this logic primarily as a single procedure.\n\nThis is the idea behind the `register_transaction_script/2` macro is to have the strongest cohesion possible for a\ngiven Use Case (Command in this case).\nDiscouraging patterns around a single Command Handler that handles multiple commands, that over time, can become a\na [God Module](https://en.wikipedia.org/wiki/God_object),\n\nGod Modules that becomes difficult to maintain and understand. Having to come up with weird names for functions, scroll\npass hundreds of lines of code to find the right piece of code to change, or bike-shedding around locations of the\ncode, to the point that some developers will annotate with comments to indicate Labels for IDEs to jump to the right\nplace, ect.","title":"About the Transaction Script naming - Trogon.Commanded.CommandRouter.register_transaction_script/2","ref":"Trogon.Commanded.CommandRouter.html#register_transaction_script/2-about-the-transaction-script-naming"},{"type":"macro","doc":"The needs for an given Aggregate is driven by the command handler that requires such \"state\", it is not the other way\naround. The same problems with the God Module can happen with the God Aggregate.\n\nIn practices, most of the `apply/2` functions will be a simple functions, barely anything passed basic permutations.\nSince the Aggregate state needs is driven by the command handler, it makes sense to have a 1:1 relationship between\nthe command and the aggregate.\n\nThe only dependency between the command handlers are the events, not the \"state\" of the aggregate. The existence of\na given event may be due to another command handler, that is OK, a set of Command Handlers acts upon the same\nfacts/events, the past is immutable, the past is the same for everyone, not the state of the aggregate.\nThat is one reason why when you are doing testing you speak in terms of \"given previous events\" and not\n\"given previous state\".\n\nThe \"Aggregate\", lets remove that word from our vocabulary, the \"Stream\" acts as a consistency boundary enforcing the\nlinearization and concurrency tolerance thru Optimistic Concurrency Control (OCC). That is all! It is about agreeing\non acting upon the same facts/events, and how its affects the future.\n\nBeing said, be pragmatic.","title":"Why to have an Aggregate per Command? - Trogon.Commanded.CommandRouter.register_transaction_script/2","ref":"Trogon.Commanded.CommandRouter.html#register_transaction_script/2-why-to-have-an-aggregate-per-command"},{"type":"macro","doc":"Q: Should I have a `command.ex` and `command/aggregate.ex` files?\nA: Yes, but it is discouraged, use the same `command.ex` file to put the\ncommand and the aggregate. As we said before, high cohesion of the code is\nthe goal, not the number of files, the more files you have, the more entropy\nyou have to deal with, and since the aggregate is driven by the command\nhandler, you are most likely to modify the command and the aggregate at the\nsame time, or in the best case, ignore the aggregate module.\n\nHere is an example file structure:\n\n    defmodule BankAccount.OpenBankAccount.Aggregate do\n      use Trogon.Commanded.Aggregate, identifier: :uuid\n      embedded_schema do\n        # ...\n      end\n    end\n\n    defmodule BankAccount.OpenBankAccount do\n      use Trogon.Commanded.CommandHandler\n      use Trogon.Commanded.Command,\n        aggregate_identifier: :uuid,\n        identity_prefix: \"bank-account-\"\n\n      alias BankAccount.{\n        BankAccountOpened,\n        OpenBankAccount\n      }\n\n      embedded_schema do\n      end\n\n      def handle(%OpenBankAccount.Aggregate{} = aggregate, %OpenBankAccount{} = command) do\n        # ...\n      end\n    end\n\n\n\nQ: Am I allowed to reuse the same aggregate for multiple commands?\nA: Yes, you can, but it is discouraged, since it can lead to the God Aggregate problem.\n\nQ: Am I allowed to reuse code between aggregates?\nA: Yes, you can, but it is discouraged, a simple copy+paste could safe you from a lot of headaches in the future. Be\nmindful of the [Rule of Three](https://en.wikipedia.org/wiki/Rule_of_three_(computer_programming)). Use the\n`MyApp.[Stream Name].[Stream Name]` module as a place to put common code between aggregates.","title":"FAQ - Trogon.Commanded.CommandRouter.register_transaction_script/2","ref":"Trogon.Commanded.CommandRouter.html#register_transaction_script/2-faq"},{"type":"module","doc":"A JSONB serializer based on events defined by `Trogon.Commanded.Event`.\n\nIt uses `Trogon.Commanded.Event` to cast the event to the correct type, by proxying, using `Ecto.Schema`s and\n`Ecto.Changeset`s.","title":"Trogon.Commanded.EventStore.JsonbSerializer","ref":"Trogon.Commanded.EventStore.JsonbSerializer.html"},{"type":"module","doc":"To use this serializer, add it to your `config.exs`:\n\n    config :my_app, MyApp.EventStore,\n      serializer: Trogon.Commanded.EventStore.JsonbSerializer,\n      types: EventStore.PostgresTypes","title":"Configuring - Trogon.Commanded.EventStore.JsonbSerializer","ref":"Trogon.Commanded.EventStore.JsonbSerializer.html#module-configuring"},{"type":"function","doc":"Deserialize given JSON binary data to the expected type.\n\nIt is already a map since `EventStore.PostgresTypes` will take care of the deserialization. Then, it will use\n`Trogon.Commanded.Event` to cast the event to the correct type.","title":"Trogon.Commanded.EventStore.JsonbSerializer.deserialize/2","ref":"Trogon.Commanded.EventStore.JsonbSerializer.html#deserialize/2"},{"type":"function","doc":"Serialize given term to JSON binary data.\n\nIt is just a passthrough, since `EventStore.PostgresTypes` will take care of the serialization.","title":"Trogon.Commanded.EventStore.JsonbSerializer.serialize/1","ref":"Trogon.Commanded.EventStore.JsonbSerializer.html#serialize/1"},{"type":"module","doc":"A JSONB serializer using `Protobuf.JSON`.","title":"Trogon.Commanded.EventStore.ProtobufJsonbSerializer","ref":"Trogon.Commanded.EventStore.ProtobufJsonbSerializer.html"},{"type":"module","doc":"To use this serializer, add it to your `config.exs`:\n\n    config :my_app, MyApp.EventStore,\n        serializer: Trogon.Commanded.EventStore.ProtobufJsonbSerializer,\n        types: EventStore.PostgresTypes","title":"Configuring - Trogon.Commanded.EventStore.ProtobufJsonbSerializer","ref":"Trogon.Commanded.EventStore.ProtobufJsonbSerializer.html#module-configuring"},{"type":"module","doc":"To serialize aggregate snapshots, you need to implement the `Trogon.Commanded.ProtobufMapper` protocol.","title":"Aggregate Snapshots - Trogon.Commanded.EventStore.ProtobufJsonbSerializer","ref":"Trogon.Commanded.EventStore.ProtobufJsonbSerializer.html#module-aggregate-snapshots"},{"type":"function","doc":"Convert given map to a `Protobuf` struct.","title":"Trogon.Commanded.EventStore.ProtobufJsonbSerializer.deserialize/2","ref":"Trogon.Commanded.EventStore.ProtobufJsonbSerializer.html#deserialize/2"},{"type":"function","doc":"Convert given `Protobuf` struct to a map.","title":"Trogon.Commanded.EventStore.ProtobufJsonbSerializer.serialize/1","ref":"Trogon.Commanded.EventStore.ProtobufJsonbSerializer.html#serialize/1"},{"type":"module","doc":"A Swiss Army Knife Helper Module.","title":"Trogon.Commanded.Helpers","ref":"Trogon.Commanded.Helpers.html"},{"type":"function","doc":"Copy the information from the `source` map into the given `target` map.\n\n    iex> Trogon.Commanded.Helpers.cast_to(%{}, %{name: \"ubi-wan\", last_name: \"kenobi\"}, [:last_name])\n    %{last_name: \"kenobi\"}","title":"Trogon.Commanded.Helpers.cast_to/3","ref":"Trogon.Commanded.Helpers.html#cast_to/3"},{"type":"type","doc":"","title":"Trogon.Commanded.Helpers.commanded_dispatch_response/0","ref":"Trogon.Commanded.Helpers.html#t:commanded_dispatch_response/0"},{"type":"type","doc":"","title":"Trogon.Commanded.Helpers.error_context/0","ref":"Trogon.Commanded.Helpers.html#t:error_context/0"},{"type":"function","doc":"Deprecated, it has the same behavior as `Trogon.Commanded.Id.new/0`.","title":"Trogon.Commanded.Helpers.generate_uuid/0","ref":"Trogon.Commanded.Helpers.html#generate_uuid/0"},{"type":"function","doc":"Ignores a specific error from a command dispatch result.\n\nThis function takes a dispatch result and an error term. If the result represents an error that matches the provided\nerror term, the function returns `:ok`. Otherwise, it returns the original result.\n\nThis is useful when an error condition should be treated as a successful operation under specific circumstances.","title":"Trogon.Commanded.Helpers.ignore_error/2","ref":"Trogon.Commanded.Helpers.html#ignore_error/2"},{"type":"function","doc":"iex> Trogon.Commanded.Helpers.ignore_error({:error, :idempotency_failure}, :idempotency_failure)\n    :ok\n\n    iex> Trogon.Commanded.Helpers.ignore_error({:error, :something_went_wrong}, :idempotency_failure)\n    {:error, :something_went_wrong}\n\n    iex> Trogon.Commanded.Helpers.ignore_error(:ok, :idempotency_failure)\n    :ok\n\n    iex> Trogon.Commanded.Helpers.ignore_error({:ok, %{name: \"Billy\"}}, :idempotency_failure)\n    {:ok, %{name: \"Billy\"}}","title":"Examples - Trogon.Commanded.Helpers.ignore_error/2","ref":"Trogon.Commanded.Helpers.html#ignore_error/2-examples"},{"type":"function","doc":"Increase the failure counter from `t:Commanded.Event.FailureContext.t/0` context by one.\n\n      iex> Trogon.Commanded.Helpers.increase_failure_counter(%Commanded.Event.FailureContext{context: %{failures_count: 1}})\n      %{failures_count: 2}","title":"Trogon.Commanded.Helpers.increase_failure_counter/1","ref":"Trogon.Commanded.Helpers.html#increase_failure_counter/1"},{"type":"function","doc":"Returns `skip` or a `retry` response.\n\nWhen the `c:Commanded.Application.dispatch/1` or `c:Commanded.Application.dispatch/2` returns an `:skip` otherwise,\nreturns a `:retry` response. Useful when you are doing error handling in your `c:Commanded.Event.Handler.error/3`.\n\n    iex> success_dispatch = fn _ -> :ok end\n    ...> Trogon.Commanded.Helpers.skip_or_retry(success_dispatch.(%{}), %{})\n    :skip\n\n    iex> success_dispatch = fn _ -> {:ok, %{}} end\n    ...> Trogon.Commanded.Helpers.skip_or_retry(success_dispatch.(%{}), %{})\n    :skip\n\n    iex> failure_dispatch = fn _ -> {:error, :ooops} end\n    ...> Trogon.Commanded.Helpers.skip_or_retry(failure_dispatch.(%{}), %{failures: 1})\n    {:retry, %{failures: 1}}","title":"Trogon.Commanded.Helpers.skip_or_retry/2","ref":"Trogon.Commanded.Helpers.html#skip_or_retry/2"},{"type":"function","doc":"Returns `skip` or a `retry` response with a given delay.\n\nWhen the `c:Commanded.Application.dispatch/1` or `c:Commanded.Application.dispatch/2` returns an `:skip` otherwise,\nreturns a `:retry` response. Useful when you are doing error handling in your `c:Commanded.Event.Handler.error/3`.\n\n    iex> success_dispatch = fn _ -> :ok end\n    ...> Trogon.Commanded.Helpers.skip_or_retry(success_dispatch.(%{}), 5_000, %{})\n    :skip\n\n    iex> success_dispatch = fn _ -> {:ok, %{}} end\n    ...> Trogon.Commanded.Helpers.skip_or_retry(success_dispatch.(%{}), 5_000, %{})\n    :skip\n\n    iex> failure_dispatch = fn _ -> {:error, :ooops} end\n    ...> Trogon.Commanded.Helpers.skip_or_retry(failure_dispatch.(%{}), 5_000, %{failures: 1})\n    {:retry, 5_000, %{failures: 1}}","title":"Trogon.Commanded.Helpers.skip_or_retry/3","ref":"Trogon.Commanded.Helpers.html#skip_or_retry/3"},{"type":"function","doc":"Transforms the given `source` map or struct into the `target` struct.","title":"Trogon.Commanded.Helpers.struct_from/2","ref":"Trogon.Commanded.Helpers.html#struct_from/2"},{"type":"function","doc":"Returns a keyword list containing the \"correlation id\" and \"causation id\" tracing.\n\n    iex> Trogon.Commanded.Helpers.tracing_from_metadata(%{\n    ...>   event_id: \"26eb06fe-9ba6-4f58-a2dd-2bdba73de4f2\",\n    ...>   correlation_id: \"f634ba94-145c-4fa7-bf7f-0d73dd83b446\"\n    ...> })\n    ...>\n    [causation_id: \"26eb06fe-9ba6-4f58-a2dd-2bdba73de4f2\", correlation_id: \"f634ba94-145c-4fa7-bf7f-0d73dd83b446\"]\n\nUseful when dispatching commands to copy-forward `t:Commanded.Event.Handler.metadata/0` tracing information.\n\n    defmodule MyProcessor do\n        application: MyApp,\n      use Commanded.Event.Handler,\n        name: \"my_processor\"\n\n      alias Trogon.Commanded.Helpers\n\n      def handle(%MyEvent{} = event, metadata) do\n        MyApp.dispatch(\n          %MyCommand{},\n          # copy-forward the information\n          Helpers.tracing_from_metadata(metadata)\n        )\n      end\n    end","title":"Trogon.Commanded.Helpers.tracing_from_metadata/1","ref":"Trogon.Commanded.Helpers.html#tracing_from_metadata/1"},{"type":"function","doc":"Adds the \"correlation id\" and \"causation id\" tracing to an existing keyword list configuration option.\n\n    iex> Trogon.Commanded.Helpers.tracing_from_metadata([timeout: 30_000], %{\n    ...>   event_id: \"26eb06fe-9ba6-4f58-a2dd-2bdba73de4f2\",\n    ...>   correlation_id: \"f634ba94-145c-4fa7-bf7f-0d73dd83b446\"\n    ...> })\n    ...>\n    [timeout: 30_000, causation_id: \"26eb06fe-9ba6-4f58-a2dd-2bdba73de4f2\", correlation_id: \"f634ba94-145c-4fa7-bf7f-0d73dd83b446\"]\n\nUseful when dispatching commands to copy-forward the `t:Commanded.Event.Handler.metadata/0` tracing information and\nwants to also add other keyword list options.\n\n    defmodule MyProcessor do\n      use Commanded.Event.Handler,\n        application: MyApp,\n        name: \"my_processor\"\n\n      alias Trogon.Commanded.Helpers\n\n      def handle(%MyEvent{} = event, metadata) do\n        MyApp.dispatch(\n          %MyCommand{},\n          # copy-forward the information\n          Helpers.tracing_from_metadata([timeout: 30_000], metadata)\n        )\n      end\n    end","title":"Trogon.Commanded.Helpers.tracing_from_metadata/2","ref":"Trogon.Commanded.Helpers.html#tracing_from_metadata/2"},{"type":"behaviour","doc":"A module for dealing IDs.","title":"Trogon.Commanded.Id","ref":"Trogon.Commanded.Id.html"},{"type":"function","doc":"Generates a UUID using the version 4 scheme, as described in\n[RFC 4122](https://datatracker.ietf.org/doc/html/rfc4122).\n\n    iex> Trogon.Commanded.Id.new() |> String.length()\n    36","title":"Trogon.Commanded.Id.new/0","ref":"Trogon.Commanded.Id.html#new/0"},{"type":"callback","doc":"Generates a new ID.","title":"Trogon.Commanded.Id.new/0","ref":"Trogon.Commanded.Id.html#c:new/0"},{"type":"protocol","doc":"Protocol for encoding and decoding `Protobuf` structs.\n\nThe protocol is required when using the `Trogon.Commanded.EventStore.ProtobufJsonbSerializer` serializer and\nworking with Aggregate snapshotting. Since the Aggregates are not `Protobuf` structs, the serializer needs to\nencode and decode them to a `Protobuf` struct.","title":"Trogon.Commanded.ProtobufMapper","ref":"Trogon.Commanded.ProtobufMapper.html"},{"type":"protocol","doc":"```elixir\ndefmodule MyApp.MyAggregate do\n  alias MyApp.Proto.MyAggregateProto\n\n  use Trogon.Commanded.Aggregate, identifier: :id\n\n  embedded_schema do\n    field(:initiated?, :boolean, default: false)\n  end\nend\n\n\ndefimpl Trogon.Commanded.ProtobufMapper, for: MyApp.MyAggregate do\n  alias MyApp.MyAggregate\n  alias MyApp.Proto.MyAggregateProto\n\n  def message_module(%MyAggregate{} = _aggregate), do: MyAggregateProto\n\n  def to_proto_message(%MyAggregate{} = aggregate) do\n    %MyAggregateProto{\n      id: aggregate.id,\n      initiated: aggregate.initiated?\n    }\n  end\n\n  def from_proto_message(%MyAggregate{} = aggregate, %MyAggregateProto{} = proto_message) do\n    aggregate\n    |> Map.put(:id, proto_message.id)\n    |> Map.put(:initiated?, proto_message.initiated)\n  end\nend\n```","title":"Example - Trogon.Commanded.ProtobufMapper","ref":"Trogon.Commanded.ProtobufMapper.html#module-example"},{"type":"function","doc":"Given the initial message, and the decoded `Protobuf` struct, returns the decoded term.\n\nThe default implementation returns the decoded term itself because implicitly expects the initial message to be a\n`Protobuf` struct. No need to map the decoded term to the initial message.","title":"Trogon.Commanded.ProtobufMapper.from_proto_message/2","ref":"Trogon.Commanded.ProtobufMapper.html#from_proto_message/2"},{"type":"function","doc":"Returns the module name of the `Protobuf` struct.\n\nThe default implementation returns the struct name of the message because implicitly expects the struct to be a\n`Protobuf` struct. No need to map the struct to the message.","title":"Trogon.Commanded.ProtobufMapper.proto_module/1","ref":"Trogon.Commanded.ProtobufMapper.html#proto_module/1"},{"type":"type","doc":"All the types that implement this protocol.","title":"Trogon.Commanded.ProtobufMapper.t/0","ref":"Trogon.Commanded.ProtobufMapper.html#t:t/0"},{"type":"function","doc":"Given a struct, returns a `Protobuf` struct.\n\nThe default implementation returns the message itself because implicitly expects the struct to be a\n`Protobuf` struct. No need to map the struct to the message.","title":"Trogon.Commanded.ProtobufMapper.to_proto_message/1","ref":"Trogon.Commanded.ProtobufMapper.html#to_proto_message/1"},{"type":"behaviour","doc":"Defines a module as a \"Query Handler\". For more information about queries, please read the following:\n\n- [CQRS pattern](https://docs.microsoft.com/en-us/azure/architecture/patterns/cqrs)","title":"Trogon.Commanded.QueryHandler","ref":"Trogon.Commanded.QueryHandler.html"},{"type":"macro","doc":"Convert the module into a `Trogon.Commanded.QueryHandler`.","title":"Trogon.Commanded.QueryHandler.__using__/1","ref":"Trogon.Commanded.QueryHandler.html#__using__/1"},{"type":"macro","doc":"defmodule MyQueryHandler do\n      use Trogon.Commanded.QueryHandler\n      import Ecto.Query, only: [from: 2]\n\n      @impl Trogon.Commanded.QueryHandler\n      def handle(params) do\n        query = from u in User,\n                  where: u.age > 18 or is_nil(params.email),\n                  select: u\n\n        {:ok, Repo.all(query)}\n      end\n    end","title":"Usage - Trogon.Commanded.QueryHandler.__using__/1","ref":"Trogon.Commanded.QueryHandler.html#__using__/1-usage"},{"type":"type","doc":"","title":"Trogon.Commanded.QueryHandler.error/0","ref":"Trogon.Commanded.QueryHandler.html#t:error/0"},{"type":"callback","doc":"Handle the incoming `params` and return the result data.","title":"Trogon.Commanded.QueryHandler.handle/1","ref":"Trogon.Commanded.QueryHandler.html#c:handle/1"},{"type":"type","doc":"","title":"Trogon.Commanded.QueryHandler.view_model/0","ref":"Trogon.Commanded.QueryHandler.html#t:view_model/0"},{"type":"module","doc":"Implements `Commanded.EventStore.TypeProvider` behavior. Using macros to generate the behavior.","title":"Trogon.Commanded.TypeProvider","ref":"Trogon.Commanded.TypeProvider.html"},{"type":"macro","doc":"Imports all the types from another module defined by `Trogon.Commanded.TypeProvider`.","title":"Trogon.Commanded.TypeProvider.import_type_provider/1","ref":"Trogon.Commanded.TypeProvider.html#import_type_provider/1"},{"type":"macro","doc":"defmodule UserTypeProvider do\n      use Trogon.Commanded.TypeProvider\n      # ...\n    end\n\n    defmodule MyAppTypeProvider do\n      use Trogon.Commanded.TypeProvider\n\n      import_type_provider UserTypeProvider\n    end","title":"Example - Trogon.Commanded.TypeProvider.import_type_provider/1","ref":"Trogon.Commanded.TypeProvider.html#import_type_provider/1-example"},{"type":"macro","doc":"Registers a mapping from an name string to an Elixir Module that defines a struct.","title":"Trogon.Commanded.TypeProvider.register_type/2","ref":"Trogon.Commanded.TypeProvider.html#register_type/2"},{"type":"macro","doc":"defmodule MyTypeProvider do\n      use Trogon.Commanded.TypeProvider,\n        prefix: \"accounts.\" # optional, adds the prefix to the type name\n\n      register_type \"account_created\", AccountCreated\n    end","title":"Example - Trogon.Commanded.TypeProvider.register_type/2","ref":"Trogon.Commanded.TypeProvider.html#register_type/2-example"},{"type":"behaviour","doc":"Defines \"Aggregate\" modules.","title":"Trogon.Commanded.Aggregate","ref":"Trogon.Commanded.Aggregate.html"},{"type":"macro","doc":"Convert the module into a `Aggregate` behaviour and a `t:t/0`.\n\nIt adds an `apply/2` callback to the module as a fallback, return the aggregate as it is.","title":"Trogon.Commanded.Aggregate.__using__/1","ref":"Trogon.Commanded.Aggregate.html#__using__/1"},{"type":"macro","doc":"- `:identifier` - The aggregate identifier key.\n- `:identity_prefix` (optional) - The prefix to be used for the identity.","title":"Options - Trogon.Commanded.Aggregate.__using__/1","ref":"Trogon.Commanded.Aggregate.html#__using__/1-options"},{"type":"macro","doc":"The `identifier` is used to identify the aggregate. It uses the `@primary_key` attribute to define the column and type.\n\n> #### Schema Field Registration {: .info}\n> `identifier` is automatically registered as a field in the `embedded_schema`.\n> Do not define the field in the `embedded_schema` yourself again.","title":"Identifier - Trogon.Commanded.Aggregate.__using__/1","ref":"Trogon.Commanded.Aggregate.html#__using__/1-identifier"},{"type":"macro","doc":"- `Trogon.Commanded.Entity`","title":"Using - Trogon.Commanded.Aggregate.__using__/1","ref":"Trogon.Commanded.Aggregate.html#__using__/1-using"},{"type":"macro","doc":"defmodule Account do\n      use Trogon.Commanded.Aggregate, identifier: :name\n\n      embedded_schema do\n        field :description, :string\n      end\n\n      @impl Trogon.Commanded.Aggregate\n      def apply(%Account{} = aggregate, %AccountOpened{} = event) do\n        aggregate\n        |> Map.put(:name, event.name)\n        |> Map.put(:description, event.description)\n      end\n    end","title":"Usage - Trogon.Commanded.Aggregate.__using__/1","ref":"Trogon.Commanded.Aggregate.html#__using__/1-usage"},{"type":"callback","doc":"Apply a given event to the aggregate returning the new aggregate state.","title":"Trogon.Commanded.Aggregate.apply/2","ref":"Trogon.Commanded.Aggregate.html#c:apply/2"},{"type":"callback","doc":"def apply(%MyAggregate{} = aggregate, %MyEvent{} = event) do\n      aggregate\n      |> Map.put(:name, event.name)\n      |> Map.put(:description, event.description)\n    end","title":"Example - Trogon.Commanded.Aggregate.apply/2","ref":"Trogon.Commanded.Aggregate.html#c:apply/2-example"},{"type":"type","doc":"","title":"Trogon.Commanded.Aggregate.event/0","ref":"Trogon.Commanded.Aggregate.html#t:event/0"},{"type":"type","doc":"A struct that represents an aggregate.","title":"Trogon.Commanded.Aggregate.t/0","ref":"Trogon.Commanded.Aggregate.html#t:t/0"},{"type":"module","doc":"Defines \"Command\" modules.","title":"Trogon.Commanded.Command","ref":"Trogon.Commanded.Command.html"},{"type":"macro","doc":"Converts the module into an `t:t/0`.","title":"Trogon.Commanded.Command.__using__/1","ref":"Trogon.Commanded.Command.html#__using__/1"},{"type":"macro","doc":"- `:aggregate_identifier` - The aggregate identifier key.\n- `:identity_prefix` (optional) - The prefix to be used for the identity.","title":"Options - Trogon.Commanded.Command.__using__/1","ref":"Trogon.Commanded.Command.html#__using__/1-options"},{"type":"macro","doc":"The `aggregate_identifier` is used to identify the aggregate that the command is associated with. It uses the\n`@primary_key` attribute to define the column and type.\n\n> #### Schema Field Registration {: .info}\n> `aggregate_identifier` is automatically registered as a field in the `embedded_schema`.\n> Do not define the field in the `embedded_schema` yourself again.","title":"Aggregate Identifier - Trogon.Commanded.Command.__using__/1","ref":"Trogon.Commanded.Command.html#__using__/1-aggregate-identifier"},{"type":"macro","doc":"- `Trogon.Commanded.ValueObject`","title":"Using - Trogon.Commanded.Command.__using__/1","ref":"Trogon.Commanded.Command.html#__using__/1-using"},{"type":"macro","doc":"defmodule MyCommand do\n      use Trogon.Commanded.Command, aggregate_identifier: :id\n\n      embedded_schema do\n        # ...\n      end\n    end\n\nYou can also define a custom type as the aggregate identifier:\n\n    defmodule IdentityRoleId do\n      use Trogon.Commanded.ValueObject\n\n      embedded_schema do\n        field :identity_id, :string\n        field :role_id, :string\n      end\n    end\n\n    defmodule AssignRole do\n      use Trogon.Commanded.Command,\n        aggregate_identifier: {:id, IdentityRoleId}\n\n      embedded_schema do\n        # ...\n      end\n    end","title":"Usage - Trogon.Commanded.Command.__using__/1","ref":"Trogon.Commanded.Command.html#__using__/1-usage"},{"type":"type","doc":"The aggregate identifier key of the event.\n\nIf it's a tuple, the type must be a module that implements the `Trogon.Commanded.ValueObject` module or [`Ecto` built-in types](https://hexdocs.pm/ecto/Ecto.Schema.html#module-types-and-casting)","title":"Trogon.Commanded.Command.aggregate_identifier_opt/0","ref":"Trogon.Commanded.Command.html#t:aggregate_identifier_opt/0"},{"type":"type","doc":"A struct that represents a command.","title":"Trogon.Commanded.Command.t/0","ref":"Trogon.Commanded.Command.html#t:t/0"},{"type":"module","doc":"Defines \"Entity\" modules.","title":"Trogon.Commanded.Entity","ref":"Trogon.Commanded.Entity.html"},{"type":"macro","doc":"Converts the module into an `t:t/0`.","title":"Trogon.Commanded.Entity.__using__/1","ref":"Trogon.Commanded.Entity.html#__using__/1"},{"type":"macro","doc":"The `identifier` is used to identify the entity. It uses the `@primary_key` attribute to define the column and type.\n\n> #### Schema Field Registration {: .info}\n> `identifier` is automatically registered as a field in the `embedded_schema`.\n> Do not define the field in the `embedded_schema` yourself again.","title":"Identifier - Trogon.Commanded.Entity.__using__/1","ref":"Trogon.Commanded.Entity.html#__using__/1-identifier"},{"type":"macro","doc":"- `Trogon.Commanded.ValueObject`","title":"Using - Trogon.Commanded.Entity.__using__/1","ref":"Trogon.Commanded.Entity.html#__using__/1-using"},{"type":"macro","doc":"defmodule MyEntity do\n      use Trogon.Commanded.Entity, identifier: :id\n\n      embedded_schema do\n        # ...\n      end\n    end\n\nYou can also define a custom type as the identifier:\n\n    defmodule IdentityRoleId do\n      use Trogon.Commanded.ValueObject\n\n      embedded_schema do\n        field :identity_id, :string\n        field :role_id, :string\n      end\n    end\n\n    defmodule IdentityRole do\n      use Trogon.Commanded.Entity,\n        identifier: {:id, IdentityRoleId}\n\n      embedded_schema do\n        # ...\n      end\n    end","title":"Usage - Trogon.Commanded.Entity.__using__/1","ref":"Trogon.Commanded.Entity.html#__using__/1-usage"},{"type":"type","doc":"The identity key of the entity.\n\nIf it's a tuple, the type must be a module that implements the `Trogon.Commanded.ValueObject` module or [`Ecto` built-in types](https://hexdocs.pm/ecto/Ecto.Schema.html#module-types-and-casting)","title":"Trogon.Commanded.Entity.identifier_opt/0","ref":"Trogon.Commanded.Entity.html#t:identifier_opt/0"},{"type":"type","doc":"The identity of an entity.","title":"Trogon.Commanded.Entity.identity/0","ref":"Trogon.Commanded.Entity.html#t:identity/0"},{"type":"type","doc":"A struct that represents an entity.","title":"Trogon.Commanded.Entity.t/0","ref":"Trogon.Commanded.Entity.html#t:t/0"},{"type":"type","doc":"","title":"Trogon.Commanded.Entity.using_opts/0","ref":"Trogon.Commanded.Entity.html#t:using_opts/0"},{"type":"module","doc":"Defines an Enum type module.","title":"Trogon.Commanded.Enum","ref":"Trogon.Commanded.Enum.html"},{"type":"macro","doc":"Converts the module into a struct with an `:value` enum field.","title":"Trogon.Commanded.Enum.__using__/1","ref":"Trogon.Commanded.Enum.html#__using__/1"},{"type":"macro","doc":"- `Ecto.Schema`\n- `Ecto.Type`","title":"Using - Trogon.Commanded.Enum.__using__/1","ref":"Trogon.Commanded.Enum.html#__using__/1-using"},{"type":"macro","doc":"- `Jason.Encoder`","title":"Derives - Trogon.Commanded.Enum.__using__/1","ref":"Trogon.Commanded.Enum.html#__using__/1-derives"},{"type":"macro","doc":"defmodule BankAccountType do\n      use Trogon.Commanded.Enum, values: [:business, :personal]\n    end\n\n    {:ok, type} = BankAccountType.new(:business)\n\nYou can use it in your `Ecto.Schema` like this:\n\n    defmodule BankAccount do\n      use Ecto.Schema\n\n      embedded_schema do\n        field :type, BankAccountType\n      end\n    end","title":"Usage - Trogon.Commanded.Enum.__using__/1","ref":"Trogon.Commanded.Enum.html#__using__/1-usage"},{"type":"module","doc":"Defines \"Event\" modules.","title":"Trogon.Commanded.Event","ref":"Trogon.Commanded.Event.html"},{"type":"macro","doc":"Converts the module into an `t:t/0`.","title":"Trogon.Commanded.Event.__using__/1","ref":"Trogon.Commanded.Event.html#__using__/1"},{"type":"macro","doc":"- `:aggregate_identifier` - The aggregate identifier key.","title":"Options - Trogon.Commanded.Event.__using__/1","ref":"Trogon.Commanded.Event.html#__using__/1-options"},{"type":"macro","doc":"The `aggregate_identifier` is used to identify the aggregate that the event is associated with. It uses the\n`@primary_key` attribute to define the column and type.\n\n> #### Schema Field Registration {: .info}\n> `aggregate_identifier` is automatically registered as a field in the `embedded_schema`.\n> Do not define the field in the `embedded_schema` yourself again.","title":"Aggregate Identifier - Trogon.Commanded.Event.__using__/1","ref":"Trogon.Commanded.Event.html#__using__/1-aggregate-identifier"},{"type":"macro","doc":"- `Trogon.Commanded.ValueObject`","title":"Using - Trogon.Commanded.Event.__using__/1","ref":"Trogon.Commanded.Event.html#__using__/1-using"},{"type":"macro","doc":"defmodule MyEvent do\n      use Trogon.Commanded.Event, aggregate_identifier: :id\n\n      embedded_schema do\n        # ...\n      end\n    end\n\nYou can also define a custom type as the aggregate identifier:\n\n    defmodule IdentityRoleId do\n      use Trogon.Commanded.ValueObject\n\n      embedded_schema do\n        field :identity_id, :string\n        field :role_id, :string\n      end\n    end\n\n    defmodule IdentityRoleAssigned do\n      use Trogon.Commanded.Event,\n        aggregate_identifier: {:id, IdentityRoleId}\n\n      embedded_schema do\n        # ...\n      end\n    end","title":"Usage - Trogon.Commanded.Event.__using__/1","ref":"Trogon.Commanded.Event.html#__using__/1-usage"},{"type":"type","doc":"The aggregate identifier key of the event.\n\nIf it's a tuple, the type must be a module that implements the `Trogon.Commanded.ValueObject` module or [`Ecto` built-in types](https://hexdocs.pm/ecto/Ecto.Schema.html#module-types-and-casting)","title":"Trogon.Commanded.Event.aggregate_identifier_opt/0","ref":"Trogon.Commanded.Event.html#t:aggregate_identifier_opt/0"},{"type":"type","doc":"A struct that represents an event.","title":"Trogon.Commanded.Event.t/0","ref":"Trogon.Commanded.Event.html#t:t/0"},{"type":"module","doc":"Defines \"Value Object\" modules.","title":"Trogon.Commanded.ValueObject","ref":"Trogon.Commanded.ValueObject.html"},{"type":"macro","doc":"Converts the module into an `Ecto.Schema` and add factory functions to create structs.","title":"Trogon.Commanded.ValueObject.__using__/1","ref":"Trogon.Commanded.ValueObject.html#__using__/1"},{"type":"macro","doc":"- `Ecto.Schema`\n- `Ecto.Type`","title":"Using - Trogon.Commanded.ValueObject.__using__/1","ref":"Trogon.Commanded.ValueObject.html#__using__/1-using"},{"type":"macro","doc":"- `Jason.Encoder`","title":"Derives - Trogon.Commanded.ValueObject.__using__/1","ref":"Trogon.Commanded.ValueObject.html#__using__/1-derives"},{"type":"macro","doc":"```elixir\ndefmodule MyValueObject do\n  use Trogon.Commanded.ValueObject\n\n  embedded_schema do\n    field :title, :string\n    # ...\n  end\nend\n```","title":"Usage - Trogon.Commanded.ValueObject.__using__/1","ref":"Trogon.Commanded.ValueObject.html#__using__/1-usage"},{"type":"macro","doc":"- `validate/2` to add custom validation to the existing `changeset/2` without overriding the whole `changeset/2`\n  function.\n\n    ```elixir\n    defmodule MyValueObject do\n      use Trogon.Commanded.ValueObject\n\n      embedded_schema do\n        field :amount, :integer\n      end\n\n      def validate(changeset, attrs) do\n        changeset\n        |> Changeset.validate_number(:amount, greater_than: 0)\n      end\n    end\n    ```\n\n- `changeset/2` returns an `t:Ecto.Changeset.t/0` for a given value object struct.\n\n    > #### Overriding Changeset {: .warning}\n    >\n    > Be careful when overriding `changeset/2` because the default\n    > implementation takes care of `cast`, `validate_required` the\n    > `@enforced_keys` and nested embeds. You may want to call\n    > `Trogon.Commanded.ValueObject.changeset/2` to have such features.\n    >\n    > If you only need to extend the changeset, you can override the\n    > `validate/2` function instead.","title":"Overridable - Trogon.Commanded.ValueObject.__using__/1","ref":"Trogon.Commanded.ValueObject.html#__using__/1-overridable"},{"type":"function","doc":"Returns an `t:Ecto.Changeset.t/0` for a given value object struct.\n\nIt reads the `@enforced_keys` from the struct and validates the required\nfields. Also, it casts the embeds. It is useful when you override the\n`changeset/2` function in your value object.","title":"Trogon.Commanded.ValueObject.changeset/2","ref":"Trogon.Commanded.ValueObject.html#changeset/2"},{"type":"function","doc":"```elixir\ndefmodule MyValueObject do\n  use Trogon.Commanded.ValueObject\n\n  @enforce_keys [:title, :amount]\n  embedded_schema do\n    field :title, :string\n    field :amount, :integer\n  end\n\n  def changeset(message, attrs) do\n    message\n    |> ValueObject.changeset(attrs)\n    |> Changeset.validate_number(:amount, greater_than: 0)\n  end\nend\n```","title":"Examples - Trogon.Commanded.ValueObject.changeset/2","ref":"Trogon.Commanded.ValueObject.html#changeset/2-examples"},{"type":"module","doc":"This module helps with test cases for testing aggregate states, and command handlers.","title":"Trogon.Commanded.TestSupport.CommandHandlerCase","ref":"Trogon.Commanded.TestSupport.CommandHandlerCase.html"},{"type":"module","doc":"- `aggregate`: The aggregate module to use in the command handler case. If not provided, then you must provide a\n  `handler` option.\n- `handler`: The command handler module to use in the command handler case. If the `aggregate` option is not provided,\n  then the `Handler.Aggregate` module will be used as the aggregate module. Read more about transaction script\n  command handler at `Trogon.Commanded.CommandRouter.register_transaction_script/2`.","title":"Options - Trogon.Commanded.TestSupport.CommandHandlerCase","ref":"Trogon.Commanded.TestSupport.CommandHandlerCase.html#module-options"},{"type":"module","doc":"After import the test support file, you should be able to have the module in your test files.\n\n    defmodule MyAggregateTest do\n      use Trogon.Commanded.TestSupport.CommandHandlerCase,\n        handler: MyCommandHandler,\n        async: true\n\n      describe \"my aggregate\" do\n        test \"should do something\" do\n          assert_events(\n            [%InitialEvent{}],\n            %DoSomething{},\n            [%SomethingHappened{}]\n          )\n        end\n\n        test \"the state\" do\n          assert_state(\n            [%InitialEvent{}],\n            %DoSomething{},\n            %MyAggregate{}\n          )\n        end\n\n        test \"the error\" do\n          assert_error(\n            [%InitialEvent{}],\n            %DoSomething{},\n            :already_exists\n          )\n        end\n      end\n    end","title":"Usage - Trogon.Commanded.TestSupport.CommandHandlerCase","ref":"Trogon.Commanded.TestSupport.CommandHandlerCase.html#module-usage"},{"type":"function","doc":"","title":"Trogon.Commanded.TestSupport.CommandHandlerCase.assert_error/5","ref":"Trogon.Commanded.TestSupport.CommandHandlerCase.html#assert_error/5"},{"type":"function","doc":"","title":"Trogon.Commanded.TestSupport.CommandHandlerCase.assert_events/5","ref":"Trogon.Commanded.TestSupport.CommandHandlerCase.html#assert_events/5"},{"type":"function","doc":"","title":"Trogon.Commanded.TestSupport.CommandHandlerCase.assert_state/5","ref":"Trogon.Commanded.TestSupport.CommandHandlerCase.html#assert_state/5"},{"type":"exception","doc":"","title":"Trogon.Commanded.TypeProvider.UnregisteredMappingError","ref":"Trogon.Commanded.TypeProvider.UnregisteredMappingError.html"},{"type":"extras","doc":"# Trogon.Commanded\n\nExtend `Commanded` package. A swiss army knife for applications following Domain-Driven Design (DDD), Event Sourcing (ES), and Command and Query Responsibility Segregation (CQRS).","title":"Trogon.Commanded","ref":"readme.html"},{"type":"extras","doc":"","title":"Documentation - Trogon.Commanded","ref":"readme.html#documentation"},{"type":"extras","doc":"- [API Reference](api-reference.html)","title":"References - Trogon.Commanded","ref":"readme.html#references"},{"type":"extras","doc":"# Changelog","title":"Changelog","ref":"changelog.html"},{"type":"extras","doc":"","title":"Unreleased - Changelog","ref":"changelog.html#unreleased"},{"type":"extras","doc":"- Initial release","title":"v0.26.0 - 2025-06-27 - Changelog","ref":"changelog.html#v0-26-0-2025-06-27"}],"proglang":"elixir","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.38.2"}}